searchNodes=[{"ref":"EventStore.html","title":"EventStore","type":"module","doc":"EventStore is an event store implemented in Elixir. It uses PostgreSQL (v9.5 or later) as the underlying storage engine. The EventStore module provides the public API to read and write events to an event stream, and subscribe to event notifications. Please refer to the following guides to learn more: Getting started Usage Subscriptions Running on a cluster of nodes Event serialization Upgrading an existing EventStore database"},{"ref":"EventStore.html#ack/2","title":"EventStore.ack/2","type":"function","doc":"Acknowledge receipt of the given events received from a single stream, or all streams, subscription. Accepts a RecordedEvent, a list of RecordedEvents, or the event number of the recorded event to acknowledge."},{"ref":"EventStore.html#append_to_stream/4","title":"EventStore.append_to_stream/4","type":"function","doc":"Append one or more events to a stream atomically. stream_uuid is used to uniquely identify a stream. expected_version is used for optimistic concurrency checks. You can provide a non-negative integer to specify the expected stream version. This is used to ensure you can only append to the stream if it is at exactly that version. You can also provide one of the following values to affect the concurrency check behaviour: :any_version - No concurrency checking; allow any stream version (including no stream). :no_stream - Ensure the stream does not exist. :stream_exists - Ensure the stream exists. events is a list of %EventStore.EventData{} structs. timeout an optional timeout for the database transaction, in milliseconds. Defaults to 15000ms. Returns :ok on success, or an {:error, reason} tagged tuple. The returned error may be due to one of the following reasons: {:error, :wrong_expected_version} when the actual stream version differs from the provided expected version. {:error, :stream_exists} when the stream exists, but expected version was :no_stream. {:error, :stream_does_not_exist} when the stream does not exist, but expected version was :stream_exists."},{"ref":"EventStore.html#configuration/0","title":"EventStore.configuration/0","type":"function","doc":"Get the event store configuration for the environment."},{"ref":"EventStore.html#delete_all_streams_subscription/1","title":"EventStore.delete_all_streams_subscription/1","type":"function","doc":"Delete an existing persistent subscription to all streams. stream_uuid is the stream the subscription is subscribed to. subscription_name is used to identify the existing subscription to remove. Returns :ok on success."},{"ref":"EventStore.html#delete_snapshot/1","title":"EventStore.delete_snapshot/1","type":"function","doc":"Delete a previously recorded snapshop for a given source. Returns :ok on success, or when the snapshot does not exist."},{"ref":"EventStore.html#delete_subscription/2","title":"EventStore.delete_subscription/2","type":"function","doc":"Delete an existing persistent subscription. stream_uuid is the stream the subscription is subscribed to. subscription_name is used to identify the existing subscription to remove. Returns :ok on success."},{"ref":"EventStore.html#link_to_stream/4","title":"EventStore.link_to_stream/4","type":"function","doc":"Link one or more existing events to another stream. Allows you to construct streams containing events already appended to any other stream. This is more efficient than copying events between streams since only a reference to the existing event is created. stream_uuid is used to uniquely identify the target stream. expected_version is used for optimistic concurrency checks. You can provide a non-negative integer to specify the expected stream version. This is used to ensure you can only append to the stream if it is at exactly that version. You can also provide one of the following values to affect the concurrency check behaviour: :any_version - No concurrency checking; allow any stream version (including no stream). :no_stream - Ensure the stream does not exist. :stream_exists - Ensure the stream exists. events_or_event_ids is a list of %EventStore.EventData{} structs or event ids. timeout an optional timeout for the database transaction, in milliseconds. Defaults to 15000ms. Returns :ok on success, or an {:error, reason} tagged tuple. The returned error may be due to one of the following reasons: {:error, :wrong_expected_version} when the actual stream version differs from the provided expected version. {:error, :stream_exists} when the stream exists, but expected version was :no_stream. {:error, :stream_does_not_exist} when the stream does not exist, but expected version was :stream_exists."},{"ref":"EventStore.html#read_all_streams_forward/3","title":"EventStore.read_all_streams_forward/3","type":"function","doc":"Reads the requested number of events from all streams, in the order in which they were originally written. start_event_number optionally, the number of the first event to read. Defaults to the beginning of the stream if not set. count optionally, the maximum number of events to read. If not set it will be limited to returning 1000 events from all streams. timeout an optional timeout for querying the database, in milliseconds. Defaults to 15000ms."},{"ref":"EventStore.html#read_snapshot/1","title":"EventStore.read_snapshot/1","type":"function","doc":"Read a snapshot, if available, for a given source. Returns {:ok, %EventStore.Snapshots.SnapshotData{}} on success, or {:error, :snapshot_not_found} when unavailable."},{"ref":"EventStore.html#read_stream_forward/4","title":"EventStore.read_stream_forward/4","type":"function","doc":"Reads the requested number of events from the given stream, in the order in which they were originally written. stream_uuid is used to uniquely identify a stream. start_version optionally, the version number of the first event to read. Defaults to the beginning of the stream if not set. count optionally, the maximum number of events to read. If not set it will be limited to returning 1000 events from the stream. timeout an optional timeout for querying the database, in milliseconds. Defaults to 15000ms."},{"ref":"EventStore.html#record_snapshot/1","title":"EventStore.record_snapshot/1","type":"function","doc":"Record a snapshot of the data and metadata for a given source. Returns :ok on success."},{"ref":"EventStore.html#stream_all_forward/3","title":"EventStore.stream_all_forward/3","type":"function","doc":"Streams events from all streams, in the order in which they were originally written. start_event_number optionally, the number of the first event to read. Defaults to the beginning of the stream if not set. read_batch_size optionally, the number of events to read at a time from storage. Defaults to reading 1000 events per batch. timeout an optional timeout for querying the database (per batch), in milliseconds. Defaults to 15000ms."},{"ref":"EventStore.html#stream_forward/4","title":"EventStore.stream_forward/4","type":"function","doc":"Streams events from the given stream, in the order in which they were originally written. start_version optionally, the version number of the first event to read. Defaults to the beginning of the stream if not set. read_batch_size optionally, the number of events to read at a time from storage. Defaults to reading 1000 events per batch. timeout an optional timeout for querying the database (per batch), in milliseconds. Defaults to 15000ms."},{"ref":"EventStore.html#subscribe/2","title":"EventStore.subscribe/2","type":"function","doc":"Create a transient subscription to a given stream. stream_uuid is the stream to subscribe to. Use the $all identifier to subscribe to events from all streams. opts is an optional map providing additional subscription configuration: selector to define a function to filter each event, i.e. returns only those elements for which fun returns a truthy value mapper to define a function to map each recorded event before sending to the subscriber. The calling process will be notified whenever new events are appended to the given stream_uuid. As the subscription is transient you do not need to acknowledge receipt of each event. The subscriber process will miss any events if it is restarted and resubscribes. If you need a persistent subscription with guaranteed at-least-once event delivery and back-pressure you should use EventStore.subscribe_to_stream/4. Notification message Events will be sent to the subscriber, in batches, as {:events, events} where events is a collection of EventStore.RecordedEvent structs. Example {:ok, subscription} = EventStore.subscribe(stream_uuid) # receive first batch of events receive do {:events, events} -&gt; IO.puts &quot;Received events: &quot; &lt;&gt; inspect(events) end"},{"ref":"EventStore.html#subscribe_to_all_streams/3","title":"EventStore.subscribe_to_all_streams/3","type":"function","doc":"Create a persistent subscription to all streams. The subscriber process will be notified of each batch of events appended to any stream. subscription_name is used to uniquely identify the subscription. subscriber is a process that will be sent {:events, events} notification messages. opts is an optional map providing additional subscription configuration: start_from is a pointer to the first event to receive. It must be one of: :origin for all events from the start of the stream (default). :current for any new events appended to the stream after the subscription has been created. any positive integer for an event id to receive events after that exact event. selector to define a function to filter each event, i.e. returns only those elements for which fun returns a truthy value mapper to define a function to map each recorded event before sending to the subscriber. concurrency_limit defines the maximum number of concurrent subscribers allowed to connect to the subscription. By default only one subscriber may connect. If too many subscribers attempt to connect to the subscription an {:error, :too_many_subscribers} is returned. The subscription will resume from the last acknowledged event if it already exists. It will ignore the start_from argument in this case. Returns {:ok, subscription} when subscription succeeds. Example {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;all_subscription&quot;, self()) # wait for the subscription confirmation receive do {:subscribed, ^subscription} -&gt; IO.puts &quot;Successfully subscribed to all streams&quot; end receive do {:events, events} -&gt; IO.puts &quot;Received events: &quot; &lt;&gt; inspect(events) # acknowledge receipt EventStore.ack(subscription, events) end"},{"ref":"EventStore.html#subscribe_to_stream/4","title":"EventStore.subscribe_to_stream/4","type":"function","doc":"Create a persistent subscription to a single stream. The subscriber process will be notified of each batch of events appended to the single stream identified by stream_uuid. stream_uuid is the stream to subscribe to. Use the $all identifier to subscribe to events from all streams. subscription_name is used to uniquely identify the subscription. subscriber is a process that will be sent {:events, events} notification messages. opts is an optional map providing additional subscription configuration: start_from is a pointer to the first event to receive. It must be one of: :origin for all events from the start of the stream (default). :current for any new events appended to the stream after the subscription has been created. any positive integer for a stream version to receive events after. selector to define a function to filter each event, i.e. returns only those elements for which fun returns a truthy value. mapper to define a function to map each recorded event before sending to the subscriber. concurrency_limit defines the maximum number of concurrent subscribers allowed to connect to the subscription. By default only one subscriber may connect. If too many subscribers attempt to connect to the subscription an {:error, :too_many_subscribers} is returned. buffer_size limits how many in-flight events will be sent to the subscriber process before acknowledgement of successful processing. This limits the number of messages sent to the subscriber and stops their message queue from getting filled with events. Defaults to one in-flight event. partition_by is an optional function used to partition events to subscribers. It can be used to guarantee processing order when multiple subscribers have subscribed to a single subscription. The function is passed a single argument (an EventStore.RecordedEvent struct) and must return the partition key. As an example to guarantee events for a single stream are processed serially, but different streams are processed concurrently, you could use the stream_uuid as the partition key. alias EventStore.RecordedEvent by_stream = fn %RecordedEvent{stream_uuid: stream_uuid} -&gt; stream_uuid end {:ok, _subscription} = EventStore.subscribe_to_stream(stream_uuid, &quot;example&quot;, self(), concurrency_limit: 10, partition_by: by_stream ) The subscription will resume from the last acknowledged event if it already exists. It will ignore the start_from argument in this case. Returns {:ok, subscription} when subscription succeeds. Notification messages Subscribers will initially receive a {:subscribed, subscription} message once the subscription has successfully subscribed. After this message events will be sent to the subscriber, in batches, as {:events, events} where events is a collection of EventStore.RecordedEvent structs. Example {:ok, subscription} = EventStore.subscribe_to_stream(stream_uuid, &quot;example&quot;, self()) # wait for the subscription confirmation receive do {:subscribed, ^subscription} -&gt; IO.puts &quot;Successfully subscribed to stream: &quot; &lt;&gt; inspect(stream_uuid) end receive do {:events, events} -&gt; IO.puts &quot;Received events: &quot; &lt;&gt; inspect(events) # acknowledge receipt EventStore.ack(subscription, events) end"},{"ref":"EventStore.html#unsubscribe_from_all_streams/1","title":"EventStore.unsubscribe_from_all_streams/1","type":"function","doc":"Unsubscribe an existing subscriber from all event notifications. subscription_name is used to identify the existing subscription process to stop. Returns :ok on success."},{"ref":"EventStore.html#unsubscribe_from_stream/2","title":"EventStore.unsubscribe_from_stream/2","type":"function","doc":"Unsubscribe an existing subscriber from event notifications. stream_uuid is the stream to unsubscribe from. subscription_name is used to identify the existing subscription process to stop. Returns :ok on success."},{"ref":"EventStore.html#t:expected_version/0","title":"EventStore.expected_version/0","type":"type","doc":""},{"ref":"EventStore.html#t:start_from/0","title":"EventStore.start_from/0","type":"type","doc":""},{"ref":"EventStore.Config.html","title":"EventStore.Config","type":"module","doc":"Provides access to the EventStore configuration."},{"ref":"EventStore.Config.html#column_data_type/0","title":"EventStore.Config.column_data_type/0","type":"function","doc":"Get the data type used to store event data and metadata. Supported data types are: &quot;bytea&quot; - Allows storage of binary strings. &quot;jsonb&quot; - Native JSON type, data is stored in a decomposed binary format that makes it slightly slower to input due to added conversion overhead, but significantly faster to process, since no reparsing is needed"},{"ref":"EventStore.Config.html#default_postgrex_opts/1","title":"EventStore.Config.default_postgrex_opts/1","type":"function","doc":""},{"ref":"EventStore.Config.html#get/0","title":"EventStore.Config.get/0","type":"function","doc":"Get the event store configuration for the environment."},{"ref":"EventStore.Config.html#get_config_integer/2","title":"EventStore.Config.get_config_integer/2","type":"function","doc":""},{"ref":"EventStore.Config.html#get_config_value/2","title":"EventStore.Config.get_config_value/2","type":"function","doc":""},{"ref":"EventStore.Config.html#get_pool/0","title":"EventStore.Config.get_pool/0","type":"function","doc":"Get the connection pool module for postgrex."},{"ref":"EventStore.Config.html#parse/1","title":"EventStore.Config.parse/1","type":"function","doc":"Normalizes the application configuration."},{"ref":"EventStore.Config.html#parse_url/1","title":"EventStore.Config.parse_url/1","type":"function","doc":"Converts a database url into a Keyword list"},{"ref":"EventStore.Config.html#parsed/0","title":"EventStore.Config.parsed/0","type":"function","doc":"Get the event store configuration for the environment."},{"ref":"EventStore.Config.html#postgrex_opts/1","title":"EventStore.Config.postgrex_opts/1","type":"function","doc":""},{"ref":"EventStore.Config.html#serializer/0","title":"EventStore.Config.serializer/0","type":"function","doc":"Get the serializer configured for the environment."},{"ref":"EventStore.Config.html#sync_connect_postgrex_opts/1","title":"EventStore.Config.sync_connect_postgrex_opts/1","type":"function","doc":""},{"ref":"Mix.Tasks.EventStore.Create.html","title":"Mix.Tasks.EventStore.Create","type":"task","doc":"Create the database for the EventStore. Examples mix event_store.create Command line options --quiet - do not log output"},{"ref":"Mix.Tasks.EventStore.Drop.html","title":"Mix.Tasks.EventStore.Drop","type":"task","doc":"Drop the database for the EventStore. Examples mix event_store.drop"},{"ref":"Mix.Tasks.EventStore.Init.html","title":"Mix.Tasks.EventStore.Init","type":"task","doc":"Initialize the database for the EventStore. Examples mix event_store.init Command line options --quiet - do not log output"},{"ref":"Mix.Tasks.EventStore.Migrate.html","title":"Mix.Tasks.EventStore.Migrate","type":"task","doc":"Migrate an existing EventStore database. Examples mix event_store.migrate Command line options --quiet - do not log output"},{"ref":"EventStore.EventData.html","title":"EventStore.EventData","type":"module","doc":"EventData contains the data for a single event before being persisted to storage"},{"ref":"EventStore.EventData.html#fetch/2","title":"EventStore.EventData.fetch/2","type":"function","doc":""},{"ref":"EventStore.EventData.html#get_and_update/3","title":"EventStore.EventData.get_and_update/3","type":"function","doc":""},{"ref":"EventStore.EventData.html#t:t/0","title":"EventStore.EventData.t/0","type":"type","doc":""},{"ref":"EventStore.EventData.html#t:uuid/0","title":"EventStore.EventData.uuid/0","type":"type","doc":""},{"ref":"EventStore.RecordedEvent.html","title":"EventStore.RecordedEvent","type":"module","doc":"EventStore.RecordedEvent contains the persisted data and metadata for a single event. Events are immutable once recorded. Recorded event fields event_number - position of the event within the stream. This will be identical to the stream_version when fetching events from a single stream. For the $all stream it will be the globally unique and ordered event number. event_id - a globally unique UUID to identify the event. stream_uuid - the original stream identity for the event. stream_version - the original version of the stream for the event. correlation_id - an optional UUID identifier used to correlate related messages. causation_id - an optional UUID identifier used to identify which message you are responding to. data - the serialized event as binary data. metadata - the serialized event metadata as binary data. created_at - the date/time, in UTC, indicating when the event was created."},{"ref":"EventStore.RecordedEvent.html#deserialize/2","title":"EventStore.RecordedEvent.deserialize/2","type":"function","doc":""},{"ref":"EventStore.RecordedEvent.html#fetch/2","title":"EventStore.RecordedEvent.fetch/2","type":"function","doc":""},{"ref":"EventStore.RecordedEvent.html#get_and_update/3","title":"EventStore.RecordedEvent.get_and_update/3","type":"function","doc":""},{"ref":"EventStore.RecordedEvent.html#t:t/0","title":"EventStore.RecordedEvent.t/0","type":"type","doc":""},{"ref":"EventStore.RecordedEvent.html#t:uuid/0","title":"EventStore.RecordedEvent.uuid/0","type":"type","doc":""},{"ref":"EventStore.Snapshots.SnapshotData.html","title":"EventStore.Snapshots.SnapshotData","type":"module","doc":"Snapshot data"},{"ref":"EventStore.Snapshots.SnapshotData.html#deserialize/2","title":"EventStore.Snapshots.SnapshotData.deserialize/2","type":"function","doc":""},{"ref":"EventStore.Snapshots.SnapshotData.html#serialize/2","title":"EventStore.Snapshots.SnapshotData.serialize/2","type":"function","doc":""},{"ref":"EventStore.Snapshots.SnapshotData.html#t:t/0","title":"EventStore.Snapshots.SnapshotData.t/0","type":"type","doc":""},{"ref":"EventStore.JsonSerializer.html","title":"EventStore.JsonSerializer","type":"module","doc":"A serializer that uses the JSON format."},{"ref":"EventStore.JsonSerializer.html#deserialize/2","title":"EventStore.JsonSerializer.deserialize/2","type":"function","doc":"Deserialize given JSON binary data to the expected type."},{"ref":"EventStore.JsonSerializer.html#serialize/1","title":"EventStore.JsonSerializer.serialize/1","type":"function","doc":"Serialize given term to JSON binary data."},{"ref":"EventStore.JsonbSerializer.html","title":"EventStore.JsonbSerializer","type":"module","doc":"Serialize to/from PostgreSQL&#39;s native jsonb format."},{"ref":"EventStore.JsonbSerializer.html#deserialize/2","title":"EventStore.JsonbSerializer.deserialize/2","type":"function","doc":"Deserialize the given data to the corresponding term Callback implementation for EventStore.Serializer.deserialize/2."},{"ref":"EventStore.JsonbSerializer.html#serialize/1","title":"EventStore.JsonbSerializer.serialize/1","type":"function","doc":"Serialize the given term to a representation that can be stored by the database. Callback implementation for EventStore.Serializer.serialize/1."},{"ref":"EventStore.JsonbSerializer.html#to_struct/2","title":"EventStore.JsonbSerializer.to_struct/2","type":"function","doc":""},{"ref":"EventStore.Serializer.html","title":"EventStore.Serializer","type":"behaviour","doc":"Specification of a serializer to convert between an Elixir term and its representation in the database."},{"ref":"EventStore.Serializer.html#c:deserialize/2","title":"EventStore.Serializer.deserialize/2","type":"callback","doc":"Deserialize the given data to the corresponding term"},{"ref":"EventStore.Serializer.html#c:serialize/1","title":"EventStore.Serializer.serialize/1","type":"callback","doc":"Serialize the given term to a representation that can be stored by the database."},{"ref":"EventStore.Serializer.html#t:config/0","title":"EventStore.Serializer.config/0","type":"type","doc":""},{"ref":"EventStore.Serializer.html#t:t/0","title":"EventStore.Serializer.t/0","type":"type","doc":""},{"ref":"EventStore.TermSerializer.html","title":"EventStore.TermSerializer","type":"module","doc":"A serializer that uses Erlang&#39;s external term format (http://erlang.org/doc/apps/erts/erl_ext_dist.html)"},{"ref":"EventStore.TermSerializer.html#deserialize/2","title":"EventStore.TermSerializer.deserialize/2","type":"function","doc":"Deserialize given binary data in Erlang&#39;s external term format."},{"ref":"EventStore.TermSerializer.html#serialize/1","title":"EventStore.TermSerializer.serialize/1","type":"function","doc":"Serialize given term to binary data."},{"ref":"EventStore.Registration.html","title":"EventStore.Registration","type":"behaviour","doc":"Registration specification for EventStore pub/sub."},{"ref":"EventStore.Registration.html#broadcast/2","title":"EventStore.Registration.broadcast/2","type":"function","doc":"Broadcasts message on given topic."},{"ref":"EventStore.Registration.html#c:broadcast/2","title":"EventStore.Registration.broadcast/2","type":"callback","doc":"Broadcasts message on given topic."},{"ref":"EventStore.Registration.html#child_spec/0","title":"EventStore.Registration.child_spec/0","type":"function","doc":"Return an optional supervisor spec for the registry."},{"ref":"EventStore.Registration.html#c:child_spec/0","title":"EventStore.Registration.child_spec/0","type":"callback","doc":"Return an optional supervisor spec for the registry."},{"ref":"EventStore.Registration.html#registry_provider/0","title":"EventStore.Registration.registry_provider/0","type":"function","doc":"Get the configured registry provider, defaults to :local if not configured."},{"ref":"EventStore.Registration.html#subscribe/2","title":"EventStore.Registration.subscribe/2","type":"function","doc":"Subscribes the caller to the given topic."},{"ref":"EventStore.Registration.html#c:subscribe/2","title":"EventStore.Registration.subscribe/2","type":"callback","doc":"Subscribes the caller to the given topic."},{"ref":"EventStore.Registration.DistributedRegistry.html","title":"EventStore.Registration.DistributedRegistry","type":"module","doc":"Pub/sub using a local registry and broadcasting messages to all connected nodes."},{"ref":"EventStore.Registration.DistributedRegistry.html#broadcast/2","title":"EventStore.Registration.DistributedRegistry.broadcast/2","type":"function","doc":"Broadcasts message on given topic."},{"ref":"EventStore.Registration.DistributedRegistry.html#child_spec/0","title":"EventStore.Registration.DistributedRegistry.child_spec/0","type":"function","doc":"Return an optional supervisor spec for the registry."},{"ref":"EventStore.Registration.DistributedRegistry.html#subscribe/2","title":"EventStore.Registration.DistributedRegistry.subscribe/2","type":"function","doc":"Subscribes the caller to the given topic."},{"ref":"EventStore.Registration.LocalRegistry.html","title":"EventStore.Registration.LocalRegistry","type":"module","doc":"Pub/sub using Elixir&#39;s local Registry module, restricted to running on a single node only."},{"ref":"EventStore.Registration.LocalRegistry.html#broadcast/2","title":"EventStore.Registration.LocalRegistry.broadcast/2","type":"function","doc":"Broadcasts message on given topic."},{"ref":"EventStore.Registration.LocalRegistry.html#child_spec/0","title":"EventStore.Registration.LocalRegistry.child_spec/0","type":"function","doc":"Return the local supervisor child spec."},{"ref":"EventStore.Registration.LocalRegistry.html#subscribe/2","title":"EventStore.Registration.LocalRegistry.subscribe/2","type":"function","doc":"Subscribes the caller to the given topic."},{"ref":"EventStore.Tasks.Create.html","title":"EventStore.Tasks.Create","type":"module","doc":"Task to create the EventStore"},{"ref":"EventStore.Tasks.Create.html#exec/2","title":"EventStore.Tasks.Create.exec/2","type":"function","doc":"Runs task Parameters config: the parsed EventStore config Opts is_mix: set to true if running as part of a Mix task quiet: set to true to silence output"},{"ref":"EventStore.Tasks.Drop.html","title":"EventStore.Tasks.Drop","type":"module","doc":"Task to drop the EventStore database."},{"ref":"EventStore.Tasks.Drop.html#exec/2","title":"EventStore.Tasks.Drop.exec/2","type":"function","doc":"Runs task Parameters config: the parsed EventStore config Opts is_mix: set to true if running as part of a Mix task quiet: set to true to silence output"},{"ref":"EventStore.Tasks.Init.html","title":"EventStore.Tasks.Init","type":"module","doc":"Task to initalize the EventStore database"},{"ref":"EventStore.Tasks.Init.html#exec/2","title":"EventStore.Tasks.Init.exec/2","type":"function","doc":"Runs task Parameters config: the parsed EventStore config Opts is_mix: set to true if running as part of a Mix task quiet: set to true to silence output"},{"ref":"EventStore.Tasks.Migrate.html","title":"EventStore.Tasks.Migrate","type":"module","doc":"Task to migrate EventStore"},{"ref":"EventStore.Tasks.Migrate.html#exec/2","title":"EventStore.Tasks.Migrate.exec/2","type":"function","doc":"Run task Parameters config: the parsed EventStore config Opts is_mix: set to true if running as part of a Mix task quiet: set to true to silence output"},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v0-17-0","title":"Changelog - v0.17.0","type":"extras","doc":"Enhancements SSL support including Mix tasks (#161). Use timestamp with time zone for timestamp fields (#150). Upgrading Upgrade your existing EventStore database by running: mix event_store.migrate Note: The migrate command is idempotent and can be safely run multiple times. You can drop and recreate an EventStore database by running: mix do event_store.drop, event_store.create, event_store.init"},{"ref":"changelog.html#v0-16-2","title":"Changelog - v0.16.2","type":"extras","doc":"Bug fixes Fix issue with concurrent subscription partitioning (#162). Reliably start EventStore.Notifications.Supervisor on :global name clash (#165)."},{"ref":"changelog.html#v0-16-1","title":"Changelog - v0.16.1","type":"extras","doc":"Bug fixes Stop Postgrex database connection process in mix event_store.init and event_store.migrate tasks after use to prevent IEx shutdown when tasks are run together (as mix do event_store.init, event_store.migrate). Ensure the event store application doesn&#39;t crash when the database connection is lost (#159)."},{"ref":"changelog.html#v0-16-0","title":"Changelog - v0.16.0","type":"extras","doc":"Enhancements Add :socket and :socket_dir config options (#132). Rename uuid dependency to elixir_uuid (#135). Subscription concurrency (#134). Send :subscribed message to all subscribers connected to a subscription (#136). Update to postgrex v0.14 (#143). Breaking changes Replace :poison with :jason for JSON event data &amp; metadata serialization (#144). To support this change you will need to derive the Jason.Encoder protocol for all of your events. This can be done by adding @derive Jason.Encoder before defining the struct in every event module. defmodule Event1 do @derive Jason.Encoder defstruct [:id, :data] end Or using Protocol.derive/2 for each event, as shown below. require Protocol for event &lt;- [Event1, Event2, Event3] do Protocol.derive(Jason.Encoder, event) end"},{"ref":"changelog.html#0-15-1","title":"Changelog - 0.15.1","type":"extras","doc":"Enhancements Use a timeout of :infinity for the migration task (mix event_store.migrate) to allow database migration to run longer than the default 15 seconds. Bug fixes Socket closing causes the event store to never receive notifications (#130). Subscription with selector function should notify pending events after all filtered (#131)."},{"ref":"changelog.html#0-15-0","title":"Changelog - 0.15.0","type":"extras","doc":"Support system environment variables for all config (#115). Allow subscriptions to filter the events they receive (#114). Allow callers to omit event_type when event data is a struct (#118). Remove dependency on psql for event_store.create, event_store.init, event_store.migrate, and event_store.drop mix tasks (#117). Supports query parameters in URL for database connection (#119). Improve typespecs and include Dialyzer in Travis CI build (#121)."},{"ref":"changelog.html#0-14-0","title":"Changelog - 0.14.0","type":"extras","doc":"Add JSONB support (#86). Add :ssl and :ssl_opts config params (#88). Make mix event_store.init task do nothing if events table already exists (#89). Timeout issue when using EventStore.read_stream_forward/3 (#92). Replace :info level logging with :debug (#90). Dealing better with Poison dependancy (#91). Publish events directly to subscriptions (#93). Use PostgreSQL advisory locks to enforce only one subscription instance (#98). Remove stream process (#99). Use PostgreSQL&#39;s NOTIFY / LISTEN for event pub/sub (#100). Link existing events to another stream (#103). Subscription notification message once successfully subscribed (#104). Transient subscriptions (#105). Transient subscription event mapping function (#108). Turn EventStore mix tasks into generic tasks for use with Distillery during deployment (#111). Upgrading Upgrade your existing EventStore database by running: mix event_store.migrate You can drop and recreate an EventStore database by running: mix do event_store.drop, event_store.create, event_store.init"},{"ref":"changelog.html#v0-13-2","title":"Changelog - v0.13.2","type":"extras","doc":"Bug fixes Use Supervisor.child_spec with an explicit id for Registry processes to support Elixir v1.5.0 and v1.5.1 (v1.5.2 contains a fix for this issue)."},{"ref":"changelog.html#v0-13-1","title":"Changelog - v0.13.1","type":"extras","doc":"Bug fixes EventStore migrate mix task read migration SQL scripts from app dir (Application.app_dir(:eventstore))."},{"ref":"changelog.html#v0-13-0","title":"Changelog - v0.13.0","type":"extras","doc":"Enhancements Use a UUID field for the event_id column, rename existing field to event_number (#75). Use uuid data type for event correlation_id and causation_id (#57). Mix task to migrate an existing EventStore database (mix event_store.migrate). Bug fixes Append to stream is limited to 7,281 events in a single request (#77). Upgrading Upgrade your existing EventStore database by running: mix event_store.migrate Or you can drop and recreate the EventStore database by running: mix do event_store.drop, event_store.create, event_store.init"},{"ref":"changelog.html#v0-12-1","title":"Changelog - v0.12.1","type":"extras","doc":"Bug fixes Publisher only notifies first pending event batch (#81)."},{"ref":"changelog.html#v0-12-0","title":"Changelog - v0.12.0","type":"extras","doc":"Enhancements Allow optimistic concurrency check on write to be optional (#31). Bug fixes Fix issue where subscription doesn&#39;t immediately receive events published while transitioning between catch-up and subscribed. Any missed events would be noticed and replayed upon next event publish."},{"ref":"changelog.html#v0-11-0","title":"Changelog - v0.11.0","type":"extras","doc":"Enhancements Support for running on a cluster of nodes using Swarm for process distribution (#53). Add stream_version column to streams table. It is used for stream info querying and optimistic concurrency checks, instead of querying the events table. Upgrading Run the schema migration v0.11.0.sql script against your event store database."},{"ref":"changelog.html#v0-10-1","title":"Changelog - v0.10.1","type":"extras","doc":"Bug fixes Fix for ack of last seen event in stream subscription (#66)."},{"ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","type":"extras","doc":"Enhancements Writer per event stream (#55). You must run the schema migration v0.10.0.sql script against your event store database. Use DBConnection&#39;s built in support for connection pools (using poolboy)."},{"ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras","doc":"Enhancements Adds causation_id alongside correlation_id for events (#48). To migrate an existing event store database execute v0.9.0.sql script. Allow single stream, and all streams, subscriptions to provide a mapper function that maps every received event before sending to the subscriber. EventStore.subscribe_to_stream(stream_uuid, &quot;subscription&quot;, subscriber, mapper: fn event -&gt; event.data end) Subscribers now receive an {:events, events} tuple and should acknowledge receipt by: EventStore.ack(subscription, events)"},{"ref":"changelog.html#v0-8-1","title":"Changelog - v0.8.1","type":"extras","doc":"Enhancements Add Access functions to EventStore.EventData and EventStore.RecordedEvent modules (#37). Allow database connection URL to be provided as a system variable (#39). Bug fixes Writer not parsing database connection URL from config (#38)."},{"ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras","doc":"Enhancements Stream events from a single stream forward."},{"ref":"changelog.html#v0-7-4","title":"Changelog - v0.7.4","type":"extras","doc":"Enhancements Subscriptions use Elixir streams to read events when catching up."},{"ref":"changelog.html#v0-7-3","title":"Changelog - v0.7.3","type":"extras","doc":"Enhancements Upgrade fsm dependency to v0.3.0 to remove Elixir 1.4 compiler warnings."},{"ref":"changelog.html#v0-7-2","title":"Changelog - v0.7.2","type":"extras","doc":"Enhancements Stream all events forward (#34)."},{"ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras","doc":"Enhancements Allow snapshots to be deleted (#26)."},{"ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras","doc":"Enhancements Subscribe to a single stream, or all streams, from a specified start position (#17)."},{"ref":"changelog.html#v0-6-2","title":"Changelog - v0.6.2","type":"extras","doc":"Bug fixes Subscriptions that are at max capacity should wait until all pending events have been acknowledged by the subscriber being catching up with any unseen events."},{"ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras","doc":"Enhancements Use IO lists to build insert events SQL statement (#23)."},{"ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras","doc":"Enhancements Use NaiveDateTime for each recorded event&#39;s created_at property."},{"ref":"changelog.html#v0-5-2","title":"Changelog - v0.5.2","type":"extras","doc":"Enhancements Provide typespecs for the public API (#16) Fix compilation warnings in mix database task (#14) Bug fixes Read stream forward does not use count to limit returned events (#10)"},{"ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras","doc":"Enhancements Ack handled events in subscribers (#18). Buffer events between publisher and subscriber (#19)."},{"ref":"getting-started.html","title":"Getting started","type":"extras","doc":"Getting started EventStore is available in Hex and can be installed as follows: Add eventstore to your list of dependencies in mix.exs: def deps do [{:eventstore, &quot;~&gt; 0.17&quot;}] end Add an eventstore config entry containing the PostgreSQL database connection details to each environment&#39;s mix config file (e.g. config/dev.exs): config :eventstore, EventStore.Storage, serializer: EventStore.TermSerializer, username: &quot;postgres&quot;, password: &quot;postgres&quot;, database: &quot;eventstore_dev&quot;, hostname: &quot;localhost&quot;, pool_size: 10, pool_overflow: 5 The database connection pool configuration options are: :pool_size - The number of connections (default: 10). :pool_overflow - The maximum number of overflow connections to start if all connections are checked out (default: 0). Create the EventStore database and tables using the mix task: $ mix do event_store.create, event_store.init"},{"ref":"getting-started.html#initialize-an-existing-database","title":"Getting started - Initialize an existing database","type":"extras","doc":"You can use an existing PostgreSQL database with EventStore by running the mix task: $ mix event_store.init"},{"ref":"getting-started.html#reset-an-existing-database","title":"Getting started - Reset an existing database","type":"extras","doc":"To drop an existing EventStore database and recreate it you can run the following mix tasks: $ mix do event_store.drop, event_store.create, event_store.init Warning this will delete all EventStore data."},{"ref":"getting-started.html#event-data-and-metadata-data-type","title":"Getting started - Event data and metadata data type","type":"extras","doc":"EventStore has support for persisting event data and metadata as either: Binary data, using the bytea data type, designed for storing binary strings. JSON data, using the jsonb data type, specifically designed for storing JSON encoded data. The default data type is bytea. This can be used with any binary serializer, such as the Erlang Term format, JSON data encoded to binary, and other serialization formats. Using the jsonb data type The advantage of using this format is that it allows you to execute ad-hoc SQL queries against the event data or metadata. If you want to use PostgreSQL&#39;s native JSON support you need to configure EventStore to use the jsonb data type. You must also use the EventStore.JsonbSerializer serializer to ensure event data and metadata is correctly serialized to JSON and include the Postgres types module (EventStore.PostgresTypes) for the Postgrex library to support JSON. # config/config.exs config :eventstore, column_data_type: &quot;jsonb&quot; config :eventstore, EventStore.Storage, serializer: EventStore.JsonbSerializer, types: EventStore.PostgresTypes Finally, you need to include the Jason library in mix.exs to enable Postgrex type with JSON support. # mix.exs defp deps do [{:jason, &quot;~&gt; 1.1&quot;}] end These settings must be configured before creating the EventStore database. It&#39;s not possible to migrate between bytea and jsonb data types once you&#39;ve created the database. This must be decided in advance."},{"ref":"usage.html","title":"Using the EventStore","type":"extras","doc":"Using the EventStore"},{"ref":"usage.html#writing-to-a-stream","title":"Using the EventStore - Writing to a stream","type":"extras","doc":"Create a unique identity for each stream. It must be a string. This example uses the uuid package. stream_uuid = UUID.uuid4() Set the expected version of the stream. This is used for optimistic concurrency. A new stream will be created when the expected version is zero. expected_version = 0 Build a list of events to persist. The data and metadata fields will be serialized to binary data. This uses your own serializer, as defined in config, that implements the EventStore.Serializer behaviour. defmodule ExampleEvent do defstruct [:key] end events = [ %EventStore.EventData{ event_type: &quot;Elixir.ExampleEvent&quot;, data: %ExampleEvent{key: &quot;value&quot;}, metadata: %{user: &quot;someuser@example.com&quot;}, } ] Append the events to the stream: :ok = EventStore.append_to_stream(stream_uuid, expected_version, events) Appending events to an existing stream The expected version should equal the number of events already persisted to the stream when appending to an existing stream. This can be set as the length of events returned from reading the stream: events = stream_uuid |&gt; EventStore.stream_forward() |&gt; Enum.to_list() stream_version = length(events) Append new events to the existing stream: new_events = [ %EventStore.EventData{...}, ... ] :ok = EventStore.append_to_stream(stream_uuid, stream_version, new_events) Why must you provide the expected stream version? This is to ensure that no events have been appended to the stream by another process between your read and subsequent write. The EventStore.append_to_stream/3 function will return {:error, :wrong_expected_version} when the version you provide is mismatched with the stream. You can resolve this error by reading the stream&#39;s events again, then attempt to append your new events using the latest stream version. Optional concurrency check You can choose to append events to a stream without using the concurrency check, or having first read them from the stream, by using one of the following values instead of the expected version: :any_version - No concurrency checking; allow any stream version (including no stream). :no_stream - Ensure the stream does not exist. :stream_exists - Ensure the stream exists. :ok = EventStore.append_to_stream(stream_uuid, :any_version, events)"},{"ref":"usage.html#reading-from-a-stream","title":"Using the EventStore - Reading from a stream","type":"extras","doc":"Read all events from a single stream, starting at the stream&#39;s first event: {:ok, events} = EventStore.read_stream_forward(stream_uuid)"},{"ref":"usage.html#reading-from-all-streams","title":"Using the EventStore - Reading from all streams","type":"extras","doc":"Read all events from all streams: {:ok, events} = EventStore.read_all_streams_forward() By default this will be limited to read the first 1,000 events from all streams only."},{"ref":"usage.html#stream-from-all-streams","title":"Using the EventStore - Stream from all streams","type":"extras","doc":"Stream all events from all streams: all_events = EventStore.stream_all_forward() |&gt; Enum.to_list() This will read all events into memory, it is for illustration only. Use the Stream functions to process the events in a memory efficient way."},{"ref":"usage.html#linking-events-between-streams","title":"Using the EventStore - Linking events between streams","type":"extras","doc":"Event linking allows you to include events in multiple streams, such as copying an event from one stream to another, but only a reference to the original event is stored. An event may be present in a stream only once, but may be linked into as many streams as required. Linked events are used to build the $all stream containing every persisted event, globally ordered. Use each recorded event&#39;s event_number field for the position of the event within the read/received stream. The stream_uuid and stream_version fields refer to the event&#39;s original stream. Read source events: {:ok, events} = EventStore.read_stream_forward(source_stream_uuid) Link read events to another stream: :ok = EventStore.link_to_stream(target_stream_uuid, 0, events) You can also pass a list of event_ids instead of recorded event structs to link events."},{"ref":"subscriptions.html","title":"Subscriptions","type":"extras","doc":"Subscriptions There are two types of subscriptions provided by EventStore: Transient subscriptions where new events are broadcast to subscribers immediately after they have been appended to storage. Persistent subscriptions which guarantee at-least-once delivery of every persisted event, provide back-pressure, and can be started, paused, and resumed from any position, including from the stream&#39;s origin."},{"ref":"subscriptions.html#event-pub-sub","title":"Subscriptions - Event pub/sub","type":"extras","doc":"PostgreSQL&#39;s LISTEN and NOTIFY commands are used to pub/sub event notifications from the database. An after update trigger on the streams table is used to execute NOTIFY for each batch of inserted events. The notification payload contains the stream uuid, stream id, and first / last stream versions (e.g. stream-12345,1,1,5). A single listener process will connect to the database to listen for these notifications. It fetches the event data and broadcasts to all interested subscriptions. This approach supports running the EventStore on multiple nodes, regardless of whether they are connected together to form a cluster. A single listener will be used when nodes form a cluster, otherwise one connection per node is used."},{"ref":"subscriptions.html#transient-subscriptions","title":"Subscriptions - Transient subscriptions","type":"extras","doc":"Use EventStore.subscribe/1 to create a transient subscription to a single stream identified by its stream_uuid. Events will be received in batches as an {:events, events} message, where events is a collection of EventStore.RecordedEvent structs. You can use $all as the stream identity to subscribe to events appended to all streams. With transient subscriptions you do not need to acknowledge receipt of the published events. The subscription will terminate when the subscriber process stops running. Subscribe to single stream events Subscribe to events appended to a single stream: :ok = EventStore.subscribe(stream_uuid) # receive first batch of events receive do {:events, events} -&gt; IO.puts(&quot;Received events: &quot; &lt;&gt; inspect(events)) end Filtering events You can provide an event selector function that filters each RecordedEvent before sending it to the subscriber: EventStore.subscribe(stream_uuid, selector: fn %EventStore.RecordedEvent{data: data} -&gt; data != nil end) # receive first batch of mapped event data receive do {:events, %EventStore.RecordedEvent{} = event_data} -&gt; IO.puts(&quot;Received non nil event data: &quot; &lt;&gt; inspect(event_data)) end Mapping events You can provide an event mapping function that maps each RecordedEvent before sending it to the subscriber: EventStore.subscribe(stream_uuid, mapper: fn %EventStore.RecordedEvent{data: data} -&gt; data end) # receive first batch of mapped event data receive do {:events, event_data} -&gt; IO.puts(&quot;Received event data: &quot; &lt;&gt; inspect(event_data)) end"},{"ref":"subscriptions.html#persistent-subscriptions","title":"Subscriptions - Persistent subscriptions","type":"extras","doc":"Persistent subscriptions to a stream will guarantee at least once delivery of every persisted event. Each subscription may be independently paused, then later resumed from where it stopped. The last received and acknowledged event is stored by the EventStore to support resuming at a later time or whenever the subscriber process restarts. A subscription can be created to receive events appended to a single or all streams. Subscriptions must be uniquely named and by default only support a single subscriber. Attempting to connect two subscribers to the same subscription will return {:error, :subscription_already_exists}. You can optionally create a competing consumer subscription with multiple subscribers. :subscribed message Once the subscription has successfully subscribed to the stream it will send the subscriber a {:subscribed, subscription} message. This indicates the subscription succeeded and you will begin receiving events. Only one instance of a subscription named subscription to a stream can connect to the database. This guarantees that starting the same subscription on each node when run on a cluster, or when running multiple single instance nodes, will only allow one subscription to actually connect. Therefore you can defer any initialisation until receipt of the {:subscribed, subscription} message to prevent duplicate effort by multiple nodes racing to create or subscribe to the same subscription. :events message For each batch of events appended to the event store your subscriber will receive a {:events, events} message. The events list is a collection of EventStore.RecordedEvent structs. Subscription start from By default subscriptions are created from the stream origin; they will receive all events from the stream. You can optionally specify a given start position: :origin - subscribe to events from the start of the stream (identical to using 0). This is the default behaviour. :current - subscribe to events from the current version. event_number (integer) - specify an exact event number to subscribe from. This will be the same as the stream version for single stream subscriptions. Ack received events Receipt of each event by the subscriber must be acknowledged. This allows the subscription to resume on failure without missing an event. The subscriber receives an {:events, events} tuple containing the published events. The subscription returned when subscribing to the stream should be used to send the ack to. This is achieved by the EventStore.ack/2 function: EventStore.ack(subscription, events) A subscriber can confirm receipt of each event in a batch by sending multiple acks, one per event. The subscriber may confirm receipt of the last event in the batch in a single ack. A subscriber will not receive further published events until it has confirmed receipt of all received events. This provides back pressure to the subscription to prevent the subscriber from being overwhelmed with messages if it cannot keep up. The subscription will buffer events until the subscriber is ready to receive, or an overflow occurs. At which point it will move into a catch-up mode and query events and replay them from storage until caught up. Subscribe to all events Subscribe to events appended to all streams: {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;example_all_subscription&quot;, self()) # wait for the subscription confirmation receive do {:subscribed, ^subscription} -&gt; IO.puts(&quot;Successfully subscribed to all streams&quot;) end receive do {:events, events} -&gt; IO.puts &quot;Received events: \#{inspect events}&quot; # acknowledge receipt EventStore.ack(subscription, events) end Unsubscribe from all streams: :ok = EventStore.unsubscribe_from_all_streams(&quot;example_all_subscription&quot;) Subscribe to single stream events Subscribe to events appended to a single stream: stream_uuid = UUID.uuid4() {:ok, subscription} = EventStore.subscribe_to_stream(stream_uuid, &quot;example_single_subscription&quot;, self()) # wait for the subscription confirmation receive do {:subscribed, ^subscription} -&gt; IO.puts(&quot;Successfully subscribed to single stream&quot;) end receive do {:events, events} -&gt; # ... process events &amp; acknowledge receipt EventStore.ack(subscription, events) end Unsubscribe from a single stream: :ok = EventStore.unsubscribe_from_stream(stream_uuid, &quot;example_single_subscription&quot;) Start subscription from a given position You can choose to receive events from a given starting position. The supported options are: :origin - Start receiving events from the beginning of the stream or all streams (default). :current - Subscribe to newly appended events only, skipping already persisted events. event_number (integer) - Specify an exact event number to subscribe from. This will be the same as the stream version for single stream subscriptions. Example all stream subscription that will receive new events appended after the subscription has been created: {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;example_subscription&quot;, self(), start_from: :current) Event Filtering You can provide an event selector function that run in the subscription process, before sending the event to your mapper and subscriber. You can use this to filter events before dispatching to a subscriber. Subscribe to all streams and provide a selector function that only sends data that the selector function returns true for. selector = fn %EventStore.RecordedEvent{event_number: event_number} -&gt; rem(event_number) == 0 end {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;example_subscription&quot;, self(), selector: selector) # wait for the subscription confirmation receive do {:subscribed, ^subscription} -&gt; IO.puts(&quot;Successfully subscribed to all streams&quot;) end receive do {:events, filtered_events} -&gt; # ... process events &amp; ack receipt using last `event_number` RecordedEvent{event_number: event_number} = List.last(filtered_events) EventStore.ack(subscription, event_number) end Mapping events You can provide an event mapping function that runs in the subscription process, before sending the event to your subscriber. You can use this to change the data received. Subscribe to all streams and provide a mapper function that sends only the event data: mapper = fn %EventStore.RecordedEvent{event_number: event_number, data: data} -&gt; {event_number, data} end {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;example_subscription&quot;, self(), mapper: mapper) # wait for the subscription confirmation receive do {:subscribed, ^subscription} -&gt; IO.puts(&quot;Successfully subscribed to all streams&quot;) end receive do {:events, mapped_events} -&gt; # ... process events &amp; ack receipt using last `event_number` {event_number, _data} = List.last(mapped_events) EventStore.ack(subscription, event_number) end Subscription concurrency A single persistent subscription can support multiple subscribers. Events will be distributed to subscribers evenly using a round-robin algorithm. The competing consumers pattern enables multiple subscribers to process events concurrently to optimise throughput, to improve scalability and availability, and to balance the workload. By default a subscription will only allow a single subscriber but you can opt-in to concurrent subscriptions be providing a non-negative concurrency_limit as a subscription option. Subscription concurrency configuration options concurrency_limit defines the maximum number of concurrent subscribers allowed to connect to the subscription. By default only one subscriber may connect. If too many subscribers attempt to connect to the subscription an {:error, :too_many_subscribers} is returned. buffer_size limits how many in-flight events will be sent to the subscriber process before acknowledgement of successful processing. This limits the number of messages sent to the subscriber and stops their message queue from getting filled with events. Defaults to one in-flight event. partition_by is an optional function used to partition events to subscribers. It can be used to guarantee processing order when multiple subscribers have subscribed to a single subscription as described in Ordering guarantee below. The function is passed a single argument (an EventStore.RecordedEvent struct) and must return the partition key. As an example to guarantee events for a single stream are processed serially, but different streams are processed concurrently, you could use the stream_uuid as the partition key. Ordering guarantee With multiple subscriber processes connected to a single subscription the ordering of event processing is no longer guaranteed since events may be processed in differing amounts of time. This can cause problems if your event handling code expects events to be processed in the order they were originally appended to a steam. You can use a partition_by function to guarantee ordering of events within a particular group (e.g. per stream) but still allow events for different groups to be processed concurrently. Partitioning gives you the benefits of competing consumers but still allows event ordering by partition where required. Partition by example alias EventStore.RecordedEvent by_stream = fn %RecordedEvent{stream_uuid: stream_uuid} -&gt; stream_uuid end {:ok, _subscription} = EventStore.subscribe_to_stream(stream_uuid, &quot;example&quot;, self(), concurrency_limit: 10, partition_by: by_stream ) The above subscription would ensure that events for each stream are processed serially (by a single subscriber) in the order they were appended to the stream, but events for any other stream can be processed concurrently by another subscriber. Example persistent subscriber Use a GenServer process to subscribe to the event store and track all notified events: # An example subscriber defmodule Subscriber do use GenServer def start_link do GenServer.start_link(__MODULE__, []) end def received_events(subscriber) do GenServer.call(subscriber, :received_events) end def init(events) do # subscribe to events from all streams {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;example_subscription&quot;, self()) {:ok, %{events: events, subscription: subscription}} end # Successfully subscribed to all streams def handle_info({:subscribed, subscription}, %{subscription: subscription} = state) do {:noreply, state} end # Event notification def handle_info({:events, events}, state) do %{events: existing_events, subscription: subscription} = state # confirm receipt of received events EventStore.ack(subscription, events) {:noreply, %{state | events: existing_events ++ events}} end def handle_call(:received_events, _from, %{events: events} = state) do {:reply, events, state} end end Start your subscriber process, which subscribes to all streams in the event store: {:ok, subscriber} = Subscriber.start_link() Deleting a persistent subscription You can delete a single stream or all stream subscription without requiring an active subscriber: :ok = EventStore.delete_subscription(stream_uuid, subscription_name) :ok = EventStore.delete_all_streams_subscription(subscription_name) Deleting the subscription will remove the subscription checkpoint allowing you to later create a subscription with the same name, using any start point. If there is an active subscriber when deleting the subscription it will be stopped."},{"ref":"event-serialization.html","title":"Event serialization","type":"extras","doc":"Event serialization The default serialization of event data and metadata uses Erlang&#39;s external term format. This is not a recommended serialization format for production usage as backwards compatibility is only guaranteed going back at least two major releases. You must implement the EventStore.Serializer behaviour to provide your preferred serialization format."},{"ref":"event-serialization.html#json-serialization-using-jason","title":"Event serialization - JSON serialization using Jason","type":"extras","doc":"EventStore includes a JSON serializer using Jason in the EventStore.JsonSerializer module. To include it add {:jason, &quot;~&gt; 1.1&quot;} to your application&#39;s mix dependencies and configure EventStore as below. config :eventstore, EventStore.Storage, serializer: EventStore.JsonSerializer"},{"ref":"event-serialization.html#example-json-serializer-using-poison","title":"Event serialization - Example JSON serializer using Poison","type":"extras","doc":"The example serializer below serializes event data and metadata to JSON using the Poison library. defmodule JsonSerializer do @moduledoc &quot;&quot;&quot; A serializer that uses the JSON format. &quot;&quot;&quot; @behaviour EventStore.Serializer @doc &quot;&quot;&quot; Serialize given term to JSON binary data. &quot;&quot;&quot; def serialize(term) do Poison.encode!(term) end @doc &quot;&quot;&quot; Deserialize given JSON binary data to the expected type. &quot;&quot;&quot; def deserialize(binary, config) do type = case Keyword.get(config, :type, nil) do nil -&gt; [] type -&gt; type |&gt; String.to_existing_atom |&gt; struct end Poison.decode!(binary, as: type) end end Configure your serializer by setting the serializer option in the mix environment configuration file (e.g. config/dev.exs). config :eventstore, EventStore.Storage, serializer: JsonSerializer You must set the event_type field to a string representing the type of event being persisted when using this serializer: %EventStore.EventData{ event_type: &quot;Elixir.ExampleEvent&quot;, data: %ExampleEvent{key: &quot;value&quot;}, metadata: %{user: &quot;someuser@example.com&quot;}, } You can use Atom.to_string/1 to get a string representation of a given event struct compatible with the example JsonSerializer module: event = %ExampleEvent{key: &quot;value&quot;} event_type = Atom.to_string(event.__struct__) #=&gt; &quot;Elixir.ExampleEvent&quot;"},{"ref":"cluster.html","title":"Running on a cluster of nodes","type":"extras","doc":"Running on a cluster of nodes EventStore supports running on multiple nodes as either a distributed Erlang cluster or as multiple single instance nodes."},{"ref":"cluster.html#event-publication","title":"Running on a cluster of nodes - Event publication","type":"extras","doc":"PostgreSQL&#39;s LISTEN / NOTIFY is used to pub/sub event notifications. A single listener process will connect to the database to listen for events when using a distributed cluster. Events will be broadcast from the single listener process to a GenServer process running on each connected node that forwards events to its local subscribers. This limits the number of database connections to at most the number of running clusters. Running EventStore on multiple nodes that are not connected together to form a cluster will result in one listener process and database connection per node."},{"ref":"cluster.html#subscriptions","title":"Running on a cluster of nodes - Subscriptions","type":"extras","doc":"PostgreSQL&#39;s advisory locks are used to limit each uniquely named subscription to run at most once. This prevents multiple instances of a subscription from running on different nodes. Advisory locks are faster than table locks, are stored in memory to avoid table bloat, and are automatically cleaned up by the server at the end of the session."},{"ref":"cluster.html#running-on-a-cluster","title":"Running on a cluster of nodes - Running on a cluster","type":"extras","doc":"Configure the EventStore to use the :distributed registry in the environment config (e.g. config/config.exs): config :eventstore, registry: :distributed"},{"ref":"cluster.html#automatic-cluster-formation","title":"Running on a cluster of nodes - Automatic cluster formation","type":"extras","doc":"You can use libcluster to automatically form clusters of Erlang nodes, with either static or dynamic node membership. You will need to include libcluster as an additional dependency: defp deps do [ {:libcluster, &quot;~&gt; 2.2&quot;}, ] end Then configure your preferred cluster topology in the environment config (e.g. config/config.exs). An example is shown below using the standard Erlang epmd daemon strategy: config :libcluster, topologies: [ example: [ strategy: Cluster.Strategy.Epmd, config: [hosts: [:&quot;node1@127.0.0.1&quot;, :&quot;node2@127.0.0.1&quot;, :&quot;node3@127.0.0.1&quot;]], ] ] Please refer to the libcluster documentation for more detail. Starting a cluster Run an Erlang Port Mapper Daemon (epmd): $ epmd -d Start an iex console per node: $ MIX_ENV=distributed iex --name node1@127.0.0.1 -S mix $ MIX_ENV=distributed iex --name node2@127.0.0.1 -S mix $ MIX_ENV=distributed iex --name node3@127.0.0.1 -S mix The cluster will be automatically formed as soon as the nodes start."},{"ref":"cluster.html#static-cluster-topology-and-formation","title":"Running on a cluster of nodes - Static cluster topology and formation","type":"extras","doc":"Instead of using libcluster you can configure the :kernel application to wait for cluster formation before starting your application during node start up. This approach is useful when you have a static cluster topology that can be defined in config. The sync_nodes_optional configuration specifies which nodes to attempt to connect to within the sync_nodes_timeout window, defined in milliseconds, before continuing with startup. There is also a sync_nodes_mandatory setting which can be used to enforce all nodes are connected within the timeout window or else the node terminates. Each node requires its own individual configuration, listing the other nodes in the cluster: # node1 config config :kernel, sync_nodes_optional: [:&quot;node2@192.168.1.1&quot;, :&quot;node3@192.168.1.2&quot;], sync_nodes_timeout: 30_000 The sync_nodes_timeout can be configured as :infinity to wait indefinitely for all nodes to connect. All involved nodes must have the same value for sync_nodes_timeout. The above approach will only work for Elixir releases. You will need to use Erlang&#39;s sys.config file for development purposes. The Erlang equivalent of the :kernerl mix config, as above, is: % node1.sys.config [{kernel, [ {sync_nodes_optional, [&#39;node2@127.0.0.1&#39;, &#39;node3@127.0.0.1&#39;]}, {sync_nodes_timeout, 30000} ]} ]. Starting a cluster Run an Erlang Port Mapper Daemon (epmd): $ epmd -d Start an iex console per node: $ MIX_ENV=distributed iex --name node1@127.0.0.1 --erl &quot;-config cluster/node1.sys.config&quot; -S mix $ MIX_ENV=distributed iex --name node2@127.0.0.1 --erl &quot;-config cluster/node2.sys.config&quot; -S mix $ MIX_ENV=distributed iex --name node3@127.0.0.1 --erl &quot;-config cluster/node3.sys.config&quot; -S mix The node specific &lt;node&gt;.sys.config files ensure the cluster is formed before starting the :eventstore application, assuming this occurs within the 30 seconds timeout. Once the cluster has formed, you can use the EventStore API from any node."},{"ref":"cluster.html#usage","title":"Running on a cluster of nodes - Usage","type":"extras","doc":"Using the EventStore when run on a cluster of nodes is identical to single node usage. You can subscribe to a stream, or all streams, on one node and append events to the stream on another. The subscription will be notified of the appended events. Append events to a stream stream_uuid = UUID.uuid4() events = EventStore.EventFactory.create_events(3) :ok = EventStore.append_to_stream(stream_uuid, 0, events) Read all events recorded_events = EventStore.stream_all_forward() |&gt; Enum.to_list() Subscribe to all Streams {:ok, subscription} = EventStore.subscribe_to_all_streams(&quot;example-subscription&quot;, self(), start_from: :origin) receive do {:subscribed, ^subscription} -&gt; IO.puts(&quot;Successfully subscribed to all streams&quot;) end receive do {:events, events} -&gt; IO.puts(&quot;Received events: \#{inspect(events)}&quot;) EventStore.ack(subscription, events) end"},{"ref":"upgrades.html","title":"Upgrading an EventStore","type":"extras","doc":"Upgrading an EventStore The CHANGELOG is used to indicate when a schema migration is required for a given version of the EventStore. You can upgrade an existing EventStore database using the following mix task: $ mix event_store.migrate Run this command each time you upgrade; it is safe to run multiple times. You must stop the :eventstore application to apply an upgrade. It is always worth taking a full backup of the EventStore database before applying an upgrade. Creating an EventStore, using the mix event_store.create task, will always use the latest database schema."}]